<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}
get_header();
$we_sidebar = get_option('we_sidebar','right');
?>
<style type="text/css">
	.we-grid-shortcode.we-grid-column-3 .item-post-n:nth-child(3n+1){ clear: left; }
	.we-grid-shortcode.we-grid-column-4 .item-post-n:nth-child(4n+1){ clear: left; }
	.we-grid-shortcode .we-listing-inner{ margin: -10px; }
	.we-listing #exmain-content h3 a { font-size: inherit; }
	.we-listing #exmain-content a.exwt-btn{ color: #fff; }
	.we-listing #exmain-content .shop-we-more-meta span {font-weight: normal;}
	.we-listing #exmain-content .we-grid-shortcode .ex-modern-blog h3,
	.we-listing #exmain-content .we-grid-shortcode .ex-modern-blog figcaption .shop-we-more-meta{padding-bottom:10px;}
</style>
<div class="exwt-container we-listing ">
	<div id="exmain-content" class="exwt-row">
	    <div id="content" class="we-main <?php echo esc_attr($we_sidebar!='hide'?'exwt-col9':'exwt-col12') ?><?php echo esc_attr(($we_sidebar == 'left') ? " revert-layout":"");?>">
			<?php
			if(get_option('we_search_enable')!='disable'){
				echo wooevent_search_view_bar();
			}
			if ( have_posts() ) : 
				?>
				<div class="we-grid-shortcode gr-classic <?php echo $we_sidebar!='hide' ? 'we-grid-column-3' : 'we-grid-column-4';?>">
					<div class="we-listing-inner">
						<?php
						global $number_excerpt,$img_size;
						$img_size = 'wethumb_460x307';
						$number_excerpt = '0';
						while ( have_posts() ) : the_post();
							wooevent_template_plugin('shop', false);
						endwhile;?>
					</div>
				</div>
				<?php
				woocommerce_pagination();
			else : 
				wc_get_template( 'loop/no-products-found.php' );
			endif;?>
	    </div>
	    <?php 
		if($we_sidebar != 'hide'){?>
	        <div class="we-sidebar exwt-col3">
	        <?php
	            /**
	             * woocommerce_sidebar hook.
	             *
	             * @hooked woocommerce_get_sidebar - 10
	             */
	            dynamic_sidebar('wooevent-sidebar');
	        ?>
	        </div>
	    <?php }?>
    </div>
</div>
<?php 
get_footer();
