<?php
get_header();
?>
<div class="we-content-speaker spk-single">
	<?php
	// Start the loop.
	while ( have_posts() ) : the_post();
		$we_custom_metadata = get_post_meta( get_the_ID(), 'we_custom_metadata', false );?>
        <div class="we-info-sp">
            <div class="exwt-row">
            <div class="exwt-col4">
            <div class="speaker-avatar">
                <?php if(has_post_thumbnail()){?>
                <div class="img-spk"><?php the_post_thumbnail('wethumb_300x300');?></div>
                <?php } ?>
                <span><?php echo get_post_meta( get_the_ID(), 'speaker_position', true );?></span>
            </div>
            </div>
            <div class="exwt-col8">
            <div class="speaker-details">
                <h3 class="speaker-title">
                    <?php the_title();?>
                </h3>
                <?php if(is_array($we_custom_metadata) && !empty($we_custom_metadata)){
					$number = count($we_custom_metadata);?>
                    <div class="we-custom-meta-info">
                    <div class="exwt-row">
                    	<?php 
						$i = 0;
						foreach($we_custom_metadata as $item){
							$i++;?>
                        	<div class="exwt-col6 exwt-col-sm6">
                                <div class="media">
                                    <div class="media-body">
                                        <div class="custom-details">
                                            <span class="sub-lb we-sub-lb"><?php echo exwe_dataes($item['we_custom_title']);?></span>
                                            <span class="we-sub-ct media-heading"><?php echo exwe_dataes($item['we_custom_content']);?></span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        	<?php 
							if($i%2==0){?>
							</div>
                            <div class="exwt-row">	
							<?php }
						}?>
                    </div>
                    </div>
                <?php }?>
                <div class="speaker-info">
                    <div class="speaker-content"><?php the_content();?></div>
                </div>
                <div class="we-social-share"><?php  echo speaker_print_social_accounts();?></div>
                <div class="speaker-event-list">
                    <h3 class="speaker-title"><?php echo get_option('we_text_upc')!='' ? get_option('we_text_upc') : esc_html__('Upcoming Events','exthemes');?></h3>
                    <?php 
                    $getlist = woo_event_query('product', 999, 'ASC', 'date', '', '', '', '', '', get_the_ID());
                    $getlist = new WP_Query($getlist);
                    if($getlist->have_posts()){
                        $post_ids = wp_list_pluck( $getlist->posts, 'ID' );
                        if(!empty($post_ids)){
                            $args = array(
                                'post_type' => 'product',
                                'posts_per_page' => -1,
                                'post_status' => 'publish',
                                'post__in' =>  $post_ids,
                                'ignore_sticky_posts' => 1,
                            );
                            $args['orderby']= 'meta_value_num';
                            $args['order']= 'ASC';
                            $args['meta_key']= 'we_startdate';
                            $args['meta_query'] = array(
                                array(
                                    'key'  => 'we_startdate',
                                    'value' => strtotime("now"),
                                    'compare' => '>'
                                )
                            );
                        }
                        $args = apply_filters( 'we_spk_args_qr', $args );
                        $getlist_ev = new WP_Query($args);
                        if($getlist_ev->have_posts()){
                            $post_ids = wp_list_pluck( $getlist_ev->posts, 'ID' );
                            if(!empty($post_ids)){
                                echo do_shortcode('[we_table orderby="post__in" order="ASC" style="1" ids="'.implode( ',', $post_ids ).'" count="100" posts_per_page="5"]');
                            }else{
                                $text = get_option('we_text_no_evf')!='' ? get_option('we_text_no_evf') : esc_html__('No Events Found','exthemes');
                                echo '<p>'.$text.'</p>';
                            }
                        }else{
                            $text = get_option('we_text_no_evf')!='' ? get_option('we_text_no_evf') : esc_html__('No Events Found','exthemes');
                            echo '<p>'.$text.'</p>';
                        }
                    }else{
                        $text = get_option('we_text_no_evf')!='' ? get_option('we_text_no_evf') : esc_html__('No Events Found','exthemes');
                        echo '<p>'.$text.'</p>';
                    }?>
                </div>
            </div>
            </div>
            </div>
        </div>
		<?php
	endwhile;?>
</div>
<?php get_footer(); ?>
